-- http://en.wikipedia.org/wiki/Hilbert_curve
-- Krisztian Pinter 2014

local lp = require "luapaint"
local lt = require "luaturtle"

function hilbert_curve(n, a, h)
    if n ~= 0 then
        lt.right(a)
        hilbert_curve(n-1,-a,h)
        lt.forward(h)
        lt.left(a)
        hilbert_curve(n-1,a,h)
        lt.forward(h)
        hilbert_curve(n-1,a,h)
        lt.left(a)
        lt.forward(h)
        hilbert_curve(n-1,-a,h)
        lt.right(a)
    end
end

image(800,800)

lt.moveto(lp.point(20,780))

hilbert_curve(7,90,6)
