-- http://en.wikipedia.org/wiki/Koch_curve
-- Krisztian Pinter 2014

local lp = require "luapaint"
local lt = require "luaturtle"

function koch(step, length)
    if step == 0 then
        lt.forward(length)
    else
        koch(step - 1, length/3)
        lt.left(60)
        koch(step - 1, length/3)
        lt.right(120)
        koch(step - 1, length/3)
        lt.left(60)
        koch(step - 1, length/3)
    end
end

image(800,250)

lt.moveto(lp.point(0,240))
lt.right(90)
koch(5, 800)