-- LuaPaint adattpusok
-- Krisztian Pinter 2014

local function color(r,g,b)
  return { r = r, g = g, b = b }
end

-- 2D pont/vektor tpus
local function point(x,y)
    return setmetatable( {
        x = x,
        y = y,
        -- Vektor elforgatsa orig krl
        rotate = function(self, angle)
            local rads = angle * math.pi / 180
            return point(self.x * math.cos(rads) - self.y * math.sin(rads),
                         self.x * math.sin(rads) + self.y * math.cos(rads))
        end,
        -- Vektor normalizlsa
        normalized = function(self)
            local len = self:length()
            return point(self.x / len, self.y / len)
        end,
        -- Vektor hossza
        length = function(self)
            return math.sqrt(self.x * self.x + self.y * self.y)
        end
    }, {
        -- Vektorsszeg
        __add = function(lhs, rhs)
            return point(lhs.x + rhs.x, lhs.y + rhs.y)
        end,
        -- Szorzs skalrral jobbrl
        __mul = function(lhs, rhs)
            return point(lhs.x * rhs, lhs.y * rhs)
        end
    })
end

return  {
    color = color,
    point = point
        }