-- LuaTurtle
-- Krisztian Pinter 2014

local lp = require "luapaint"

-- A teknc llapott ler vltozk.
local pos = lp.point(0,0)       -- hely    
local dir = -90                 -- szg
local pendn = true              -- toll letve
local penclr = lp.color(0,0,0)  -- toll szne

-- Egyszer setterek
local function pencolor(color)
    penclr = color
end

local function penup()
    pendn = false
end

local function pendown()
    pendn = true
end

-- Forgats
local function left(angle)
    dir = (dir - angle) % 360
end

local function right(angle)
    dir = (dir + angle) % 360
end

-- Teknc thelyezse rajzols nlkl
local function moveto(target)
    pos = target
end

-- Rajzols elre
local function forward(distance)
    local rads = dir * math.pi / 180
    -- Az j koordintkat tszmoljuk a teknc polrkoordintarendszerbl
    local newpos = pos + lp.point(math.cos(rads), math.sin(rads)) * distance
    if pendn then
        line(pos, newpos, penclr)
    end
    pos = newpos
end

local function backward(distance)
    forward(-distance)
end
        
return  {
    pencolor = pencolor,
    penup = penup,
    pendown = pendown,
    left = left,
    right = right,
    moveto = moveto,
    forward = forward,
    backward = backward
        }