-- Fggvnyrajzol
-- Krisztian Pinter 2014

local lp = require "luapaint"

-- Intervallum tpus
function range(low, high)
    local l
    local h
    if low < high then l,h = low,high else l,h = high,low end
    return  {
        low = l,
        high = h
            }
end

-- Fggvnyrajzol fggvny
-- paramterek:
-- fun          - R->R fggvny,    kirajzoland fggvny
-- dest         - point,            a kirajzolt grafikon bal fels sarka
-- size         - point,            a kirajzolt grafikon mrete
-- dom          - range,            a megjelentend rtktartomny
-- rng          - range,            a megjelentend rtkkszlet
-- draw_axes    - bool,             kirajzoljuk-e az x s y tengelyeket
function plot_function(fun, dest, size, dom, rng, draw_axes)
    local d1 = dest         -- bal fels sarok
    local d2 = dest + size  -- jobb als sarok
    
    -- keret kirajzolsa
    line(d1,lp.point(d1.x,d2.y),lp.color(0,0,0))
    line(d1,lp.point(d2.x,d1.y),lp.color(0,0,0))
    line(d2,lp.point(d1.x,d2.y),lp.color(0,0,0))
    line(d2,lp.point(d2.x,d1.y),lp.color(0,0,0))
    
    -- tengelyek kirajzolsa, draw_axes alaprtelmezsben true
    if draw_axes == nil or draw_axes == true then
        local axis_x = (-rng.low)/(rng.high-rng.low)
        local axis_y = (-dom.low)/(dom.high-dom.low)
        if 0 < axis_x and axis_x < 1 then
            line(   lp.point(0     , axis_x * size.y) + dest
                ,   lp.point(size.x, axis_x * size.y) + dest
                ,   lp.color(0,0,0))
        end
        if 0 < axis_y and axis_y < 1 then
            line(   lp.point(axis_y * size.x, 0     ) + dest
                ,   lp.point(axis_y * size.x, size.y) + dest
                ,   lp.color(0,0,0))
        end
    end
    
    local height = size.y
    local width  = size.x
    
    -- fggvny kirajzolsa, minden pixeloszlopbani kirtkelsvel
    for i=0,width-1 do
        local ii0 = ( i   /(width-1))*(dom.high-dom.low)+dom.low
        local ii1 = ((i+1)/(width-1))*(dom.high-dom.low)+dom.low
        local j0 = 1-(fun(ii0)-rng.low)/(rng.high-rng.low)
        local j1 = 1-(fun(ii1)-rng.low)/(rng.high-rng.low)
        if j0 < 0 then j0 = 0 elseif j0 > 1 then j0 = 1 end
        if j1 < 0 then j1 = 0 elseif j1 > 1 then j1 = 1 end
        line(   lp.point(i  ,j0*height) + dest
            ,   lp.point(i+1,j1*height) + dest
            ,   lp.color(0,0,0))
    end
end

-- Fggvnykompozci
function o(f,g) return function(x) return f(g(x)) end end

function poly(x) return x*(x-1)*(x-2)*(x-3)*(x-4) end


image(940,630)

plot_size = lp.point(300,300)

plot_function(math.sin, lp.point( 10, 10), plot_size, range(-math.pi,math.pi), range(-1,1))
plot_function(o(math.cos,math.sin), lp.point(320, 10), plot_size, range(-math.pi,math.pi), range(0,1))
plot_function(o(math.abs,math.cos), lp.point(630, 10), plot_size, range(-math.pi,math.pi), range(0,1), false)

plot_function(o(math.cos,poly), lp.point( 10, 320), plot_size, range(-1,3), range(-5,5))
plot_function((poly), lp.point(320, 320), lp.point(610,300), range(-1,5), range(-10,10))