-- http://en.wikipedia.org/wiki/Sierpinski_triangle
-- Krisztian Pinter 2014

local lp = require "luapaint"
local lt = require "luaturtle"

function sierpinski_triangle(step, length)
    if step == 0 then
        for i = 1,3 do
            lt.forward(length)
            lt.right(120)
        end
    else
        sierpinski_triangle(step - 1, length / 2)
        lt.penup() lt.forward(length / 2) lt.pendown()
        sierpinski_triangle(step - 1, length / 2)
        lt.penup() lt.right(120) lt.forward(length / 2)
            lt.left(120) lt.pendown()
        sierpinski_triangle(step - 1, length / 2)
        lt.penup() lt.left(120) lt.forward(length / 2)
            lt.right(120) lt.pendown()        
    end
end

image(800,700)

lt.moveto(lp.point(20,680))

lt.right(30)
sierpinski_triangle(7,760)